#!/usr/bin/arch -arm64 /usr/bin/env bash --login
#
# Script for downloading and injecting dependencies using a fresh Miniforge
#

BASEDIR=`dirname $0`
BASEDIR=$BASEDIR/../..

osascript -e "tell app \"System Events\" to display dialog \"Will download inject dependencies using latest Miniforge :-) \"" 
ret_code0=$?

if [ "$ret_code0" != "0" ];
then
    echo "User cancelled..."
    rm ${BASEDIR}/Contents/Resources/INJECTING
    exit
else
    (cd /tmp && curl -L -O https://raw.githubusercontent.com/McStasMcXtrace/McCode/main/mcxtrace-environment.yml)
    ret_code1=$?
    if [ "$ret_code1" != "0" ];
    then
	osascript -e "tell app \"System Events\" to display dialog \"Error: Failure occured during download of mcxtrace-environment.yml... :-( \""
    else
	(cd /tmp && curl -L -O "https://github.com/conda-forge/miniforge/releases/latest/download/Miniforge3-$(uname)-$(uname -m).sh")
	ret_code2=$?
	if [ "$ret_code2" != "0" ];
	then
	    osascript -e "tell app \"System Events\" to display dialog \"Error: Failure occured during download of Miniforge3 installer... :-( \""
	else
	    bash /tmp/Miniforge3-$(uname)-$(uname -m).sh -p ${BASEDIR}/Contents/Resources/miniconda3/ -b
	    ret_code3=$?
	    if [ "$ret_code3" != "0" ];
	    then
		osascript -e "tell app \"System Events\" to display dialog \"Error: Failure during execution of Miniforge3 installer... :-( \""
	    else
		MCCONDADIR=`dirname $(readlink -f ${BASEDIR}/Contents/Resources/miniconda3/bin)`
		echo Attempting shell-hook activate of MCCONDADIR=${MCCONDADIR}
		"$(${MCCONDADIR}/bin/conda shell.bash hook)"
		ret_code4=$?
		if [ "$ret_code4" != "0" ];
		then
		    echo Fallback source $MCCONDADIR/bin/activate
		    source $MCCONDADIR/bin/activate
		    ret_code4=$?
		fi
		if [ "$ret_code4" != "0" ];
		then
		    osascript -e "tell app \"System Events\" to display dialog \"Error: Failure activating Miniforge3 env... :-( \""
		else
		    conda update conda -y
		    ret_code5=$?
		    if [ "$ret_code5" != "0" ];
		    then
			osascript -e "tell app \"System Events\" to display dialog \"Error: Failure occured during conda update conda -y... :-( \""
		    else
			conda install -c conda-forge -c nodefaults mcxtrace=3.5.1 jupytext jupyterlab ipympl scipy numpy -y
			pip install mcstasscript
			ret_code6=$?
			if [ "$ret_code6" != "0" ];
			then
			    osascript -e "tell app \"System Events\" to display dialog \"Error: Failure injecting dependencies... :-( \""
			else
			    mxdoc -i
			    ret_code7=$?
			    if [ "$ret_code7" != "0" ];
			    then
				osascript -e "tell app \"System Events\" to display dialog \"Error during mxdoc -i step... :-( \""
			    else
				osascript -e "tell app \"System Events\" to display dialog \"Your mcxtrace should now contain the necessary dependencies! :-) \""
				rm ${BASEDIR}/Contents/Resources/INJECTING
			    fi
			fi
		    fi
		fi
	    fi
	fi
    fi
fi
